
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <new.h>

#include "AirFileReader1.h"

/**
*/
void allocation_handler()
{
   cout << "Out of Memory. Aborting Program...."<< endl;
   exit(1);
}

/**
*/
printAll(ostream & os, FlightSchedule& fSchedule, CityList& ctyList)
{
   int i;
   Flight* crr;
   City*   dep;
   City*   arr;

   for(i=0;i<fSchedule.getNumberOfFlights();i++)
   {
      crr = fSchedule.getFlightWithIndex(i);

      if( crr != NULL )
      {
         dep = ctyList.getCity(crr->getFromIndex());
         arr = ctyList.getCity(crr->getToIndex());
    
         if( dep != NULL && arr != NULL )
         { 
        
           os << dep->getName() << " " ;
           os << arr->getName() << " " ;
           os << crr->getDepartureDate() << " " ;
           os << crr->getArrivalDate() << " " ;
           os << crr->getFlightId() << " " ;
           os << crr->getPlaneType() << " " << endl;

         }// end of if

      }// end of if

   }// end of for

}// end of printAll()

/**
* Finds the Initial solutions.
*/
main(int argc, char *argv[])
{  int i;

   // Set Allocation Exception Handler
   set_new_handler(allocation_handler);
   srand(150);

   AirFileReader1 Reader("data");
   if(argc>1) Reader.setFileName(argv[1]);

   FlightSchedule fSchedule;
   CityList ctyList;
   Reader.read(fSchedule,ctyList);

   cout << " Cities " << ctyList << endl;
   cout << " Flights " << fSchedule << endl;

   ofstream out("schedule.out"); 
   printAll(out, fSchedule, ctyList);
   out.close();
   //AirScheduleProblem Prob ;
   //Reader.read(Prob);

}
